//
// PhotoStamper | Arguments.java
// Copyright (c) 2007-2008 Neil Johan
// http://www.neiljohan.com/software/photostamper/
//

import java.util.HashMap;
import java.util.Stack;

public class Arguments 
{
	private HashMap<String,String> iFlags = new HashMap<String,String>();
	
	private Arguments(String[] aArgs)
	{
		Stack<String> argStack = new Stack<String>();
		for (int i=aArgs.length-1; i>=0; --i)
		{
			argStack.push(aArgs[i]);
		}
		while (!argStack.isEmpty())
		{
			final String arg = argStack.pop();
			if (isFlagType(arg))
			{
				final String nextValue = argStack.peek();
				if (nextValue != null && isFlagType(nextValue))
				{
					// flag with no value
					iFlags.put(arg.substring(1), null);
					Output.debug("Add flag: " + arg.substring(1));
				}
				else
				{
					// flag with value
					final String value = argStack.pop();
					iFlags.put(arg.substring(1), value);
					Output.debug("Add flag: " + arg.substring(1) + " " + value);
				}
			}
		}
	}
	
	private boolean isFlagType(String aFlag)
	{
		return aFlag.length() > 1 && (aFlag.charAt(0) == '-' || aFlag.charAt(0) == '/');
	}
	
	public boolean isFlagSet(String aFlag)
	{
		return iFlags.containsKey(aFlag);
	}

	public String getFlagValue(String aFlag)
	{
		return iFlags.get(aFlag);
	}
	
	public static Arguments parse(String[] aArgs)
	{
		return new Arguments(aArgs);
	}
}
